/***************************************************************/
/*                  Recorder                                   */
/***************************************************************/
/*    Written : 23-04-1992                                     */
/*         By : Neil Johnson                                   */
/*        For : IBM PC & Compatibles                           */
/*   Language : Microsoft C ( written in QuickC 2.5 )          */
/*    Version : 1.0                                            */
/***************************************************************/
/*                 Notes :-                                    */
/*  1) Compile using atleast the COMPACT memory model.         */
/***************************************************************/



#include <malloc.h>
#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <fcntl.h>          /* O_ constant definitions */
#include <process.h>
#include <stdlib.h>


#define BASE_PORT 768

#include "intrcrd1.c"

main()
    {
    unsigned int sam_len,del,result;
    char string[30];
    unsigned char *sample_ptr;
    int filehandle;

    printf("\n\n\n\nRecorder v1.0 - record samples with InterCard 1 board");
    printf("\n-----------------------------------------------------\n\n");
    printf("Enter No. Of Samples (max 65000):");
    gets(string);
    sam_len=atoi(string);
    printf("Enter delay (0 to 255):");
    gets(string);
    del=atoi(string);
    if (del>255)
       {
       printf("Sorry, delay too long\n\n");
       exit(0);
       }

    /* now allocate enough memory for the sample */

    if ( (sample_ptr=(unsigned char*) malloc((size_t)sam_len))==NULL)
       {
       printf("Sorry, not enough memory.\n\n");
       exit(1);
       }

    /* o.k. got block of memory, now get ready to take sample... */
    printf("\nPress RETURN key to start recording...\n\n");
    gets(string);

    /* o.k. now record the sample*/

    if ((result=_GetSample ( sample_ptr, sam_len, (unsigned char)del))==-1)
       {
       printf("Sorry, can't get sample.\n\n");
       exit(2);
       }

    printf("Sample now in memory.\n\n");
    printf("Press key to play sample...");
    gets(string);
    del++;
    if ((result=_PlaySample ( sample_ptr, sam_len, (unsigned char)del))==-1)
       {
       printf("Sorry, can't play sample.\n\n");
       exit(2);
       }

    printf("Do you want to save sample to disk ? (y/n)");
    gets(string);
    if (string[0]==121)
       {
       printf("\n\nEnter name of file:");
       gets(string);

       if( ( filehandle=open( string,O_CREAT | O_WRONLY) ) == -1L)
	  {
	  printf("\n Sorry, I cannot open that sound file\n\n");
	  exit(1);
	  }
       if( write( filehandle,sample_ptr,(unsigned)sam_len ) == -1 )
	  {
	  printf("Sorry, for some reason I can't write that sound file. \n\n" );
	  exit(1);
	  }
       }

    free(sample_ptr);
    }

/************************************************************************/


